#line 1 "C:/0/! ! ! LCD BarGraph Ver1.2/MyProject.c"
#line 15 "C:/0/! ! ! LCD BarGraph Ver1.2/MyProject.c"
sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;
sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;

unsigned int adc_rd, diff, adc_perc;
unsigned long int BarSegmentNum;
char adcprint, i;

const char character[] = {31,31,31,31,31,31,31,31};

void CustomChar(char pos_row, char pos_char)
 {
 char ip;
 Lcd_Cmd(64);
 for (ip = 0; ip<=7; ip++) Lcd_Chr_CP(character[ip]);
 Lcd_Cmd(_LCD_RETURN_HOME);
 Lcd_Chr(pos_row, pos_char, 0);
 }

void main()
{
 ANSELA.F0 = 1;
 TRISA.F0 = 1;

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);


 while(1)
 {
 adc_rd = ADC_Read(0);
 adc_perc = adc_rd/(1023/100);
 if (adc_perc > 0) adc_perc = adc_perc - 2;
 inttostr(adc_perc, adcprint);
 Lcd_out(1,4,adcprint);
 Lcd_chr(1,10,'%');

 Lcd_out(1,1,"0%");
 Lcd_out(1,13,"100%");

 if (diff != adc_rd)
 {
 BarSegmentNum = adc_rd/(1023/16);

 Lcd_out(2,1,"                ");

 for (i=0;i<BarSegmentNum;i++)
 {
 CustomChar(2,i+1);
 }
 }
 Delay_ms(1500);

 diff = adc_rd;
 }
}
