#line 1 "C:/0/! ! ! LCD BarGraph Ver1.6/MyProject.c"
#line 13 "C:/0/! ! ! LCD BarGraph Ver1.6/MyProject.c"
sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;
sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;

unsigned int adc_rd, diff;
unsigned long int BarSegmentNum;
char adcprint, i, ip;

const char character1[] = {14,27,17,17,17,17,17,31};
const char character2[] = {14,27,17,17,17,17,31,31};
const char character3[] = {14,27,17,17,17,31,31,31};
const char character4[] = {14,27,17,17,31,31,31,31};
const char character5[] = {14,27,17,31,31,31,31,31};
const char character6[] = {14,27,31,31,31,31,31,31};
const char character7[] = {14,31,31,31,31,31,31,31};

void main()
{
 ANSELA.F0 = 1;
 TRISA.F0 = 1;

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);



 Lcd_Cmd(64);
 for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character1[ip]);

 Lcd_Cmd(72);
 for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character2[ip]);

 Lcd_Cmd(80);
 for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character3[ip]);

 Lcd_Cmd(88);
 for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character4[ip]);

 Lcd_Cmd(96);
 for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character5[ip]);

 Lcd_Cmd(104);
 for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character6[ip]);

 Lcd_Cmd(112);
 for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character7[ip]);

 ADC_Init();

 while(1)
 {
 adc_rd = ADC_Get_Sample(0);

 if (diff != adc_rd)
 {
 if (adc_rd < 146)
 {
 Lcd_Chr(2,1, 0);
 }
 if ((adc_rd > 146) && (adc_rd < 292))
 {
 Lcd_Chr(2,1, 1);
 }
 if ((adc_rd > 292) && (adc_rd < 438))
 {
 Lcd_Chr(2,1, 2);
 }
 if ((adc_rd > 438) && (adc_rd < 584))
 {
 Lcd_Chr(2,1, 3);
 }
 if ((adc_rd > 584) && (adc_rd < 730))
 {
 Lcd_Chr(2,1, 4);
 }
 if ((adc_rd > 730) && (adc_rd < 876))
 {
 Lcd_Chr(2,1, 5);
 }
 if (adc_rd > 876)
 {
 Lcd_Chr(2,1, 6);
 }

 }
 Delay_ms(1000);
 diff = adc_rd;
 }

}
