
_main:

;MyProject.c,31 :: 		void main()
;MyProject.c,33 :: 		ANSELA.F0 = 1;            // Configure RA0 pin as analog
	BSF         ANSELA+0, 0 
;MyProject.c,34 :: 		TRISA.F0  = 1;            // Configure RA0 pin as input
	BSF         TRISA+0, 0 
;MyProject.c,36 :: 		Lcd_Init();               // Initialize LCD
	CALL        _Lcd_Init+0, 0
;MyProject.c,37 :: 		Lcd_Cmd(_LCD_CLEAR);      // Clear LCD
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,38 :: 		Lcd_Cmd(_LCD_CURSOR_OFF); // Turn cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,41 :: 		while(1)
L_main0:
;MyProject.c,43 :: 		adc_rd = ADC_Read(0);         // Get ADC value from 1st channel
	CLRF        FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _adc_rd+0 
	MOVF        R1, 0 
	MOVWF       _adc_rd+1 
;MyProject.c,44 :: 		wordtostr(adc_rd, adcprint);  // Conversion to string
	MOVF        R0, 0 
	MOVWF       FARG_WordToStr_input+0 
	MOVF        R1, 0 
	MOVWF       FARG_WordToStr_input+1 
	MOVF        _adcprint+0, 0 
	MOVWF       FARG_WordToStr_output+0 
	MOVLW       0
	MOVWF       FARG_WordToStr_output+1 
	CALL        _WordToStr+0, 0
;MyProject.c,45 :: 		Lcd_out(1,5,adcprint);        // Prints ADC steps in LCD first row
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       5
	MOVWF       FARG_Lcd_Out_column+0 
	MOVF        _adcprint+0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       0
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,47 :: 		BarSegmentNum = adc_rd/(1023/16); // Calculate numbers of bar graph segments
	MOVLW       63
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        _adc_rd+0, 0 
	MOVWF       R0 
	MOVF        _adc_rd+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVF        R0, 0 
	MOVWF       _BarSegmentNum+0 
	MOVF        R1, 0 
	MOVWF       _BarSegmentNum+1 
	MOVLW       0
	MOVWF       _BarSegmentNum+2 
	MOVWF       _BarSegmentNum+3 
;MyProject.c,49 :: 		Lcd_out(2,1,"                ");  // Clears LCD second row
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr1_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr1_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,51 :: 		for (i=0;i<BarSegmentNum;i++)     // Loop to print each bar segment in second row
	CLRF        _i+0 
L_main2:
	MOVF        _BarSegmentNum+3, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main7
	MOVF        _BarSegmentNum+2, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main7
	MOVF        _BarSegmentNum+1, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main7
	MOVF        _BarSegmentNum+0, 0 
	SUBWF       _i+0, 0 
L__main7:
	BTFSC       STATUS+0, 0 
	GOTO        L_main3
;MyProject.c,53 :: 		Lcd_out(2,i+1,">");         // Prints bar graph segment symbol
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVF        _i+0, 0 
	ADDLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr2_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr2_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,51 :: 		for (i=0;i<BarSegmentNum;i++)     // Loop to print each bar segment in second row
	INCF        _i+0, 1 
;MyProject.c,54 :: 		}
	GOTO        L_main2
L_main3:
;MyProject.c,56 :: 		Delay_ms(500);                    // Stabilize LCD display
	MOVLW       21
	MOVWF       R11, 0
	MOVLW       75
	MOVWF       R12, 0
	MOVLW       190
	MOVWF       R13, 0
L_main5:
	DECFSZ      R13, 1, 1
	BRA         L_main5
	DECFSZ      R12, 1, 1
	BRA         L_main5
	DECFSZ      R11, 1, 1
	BRA         L_main5
	NOP
;MyProject.c,57 :: 		}
	GOTO        L_main0
;MyProject.c,59 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
