
_CustomChar:

;MyProject.c,34 :: 		void CustomChar(char pos_row, char pos_char)
;MyProject.c,37 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,38 :: 		for (ip = 0; ip<=7; ip++) Lcd_Chr_CP(character[ip]);
	CLRF        CustomChar_ip_L0+0 
L_CustomChar0:
	MOVF        CustomChar_ip_L0+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_CustomChar1
	MOVLW       _character+0
	ADDWF       CustomChar_ip_L0+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        CustomChar_ip_L0+0, 1 
	GOTO        L_CustomChar0
L_CustomChar1:
;MyProject.c,39 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,40 :: 		Lcd_Chr(pos_row, pos_char, 0);
	MOVF        FARG_CustomChar_pos_row+0, 0 
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVF        FARG_CustomChar_pos_char+0, 0 
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,41 :: 		}
L_end_CustomChar:
	RETURN      0
; end of _CustomChar

_main:

;MyProject.c,43 :: 		void main()
;MyProject.c,45 :: 		ANSELA.F0 = 1;            // Configure RA0 pin as analog
	BSF         ANSELA+0, 0 
;MyProject.c,46 :: 		TRISA.F0  = 1;            // Configure RA0 pin as input
	BSF         TRISA+0, 0 
;MyProject.c,48 :: 		Lcd_Init();               // Initialize LCD
	CALL        _Lcd_Init+0, 0
;MyProject.c,49 :: 		Lcd_Cmd(_LCD_CLEAR);      // Clear LCD
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,50 :: 		Lcd_Cmd(_LCD_CURSOR_OFF); // Turn cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,53 :: 		while(1)
L_main3:
;MyProject.c,55 :: 		adc_rd = ADC_Read(0);         // Get ADC value from 1st channel
	CLRF        FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _adc_rd+0 
	MOVF        R1, 0 
	MOVWF       _adc_rd+1 
;MyProject.c,56 :: 		inttostr(adc_rd, adcprint);   // Conversion to string
	MOVF        R0, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVF        R1, 0 
	MOVWF       FARG_IntToStr_input+1 
	MOVF        _adcprint+0, 0 
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       0
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;MyProject.c,57 :: 		Lcd_out(1,5,adcprint);        // Prints ADC steps in LCD first row
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       5
	MOVWF       FARG_Lcd_Out_column+0 
	MOVF        _adcprint+0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       0
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,59 :: 		if (diff != adc_rd)
	MOVF        _diff+1, 0 
	XORWF       _adc_rd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main12
	MOVF        _adc_rd+0, 0 
	XORWF       _diff+0, 0 
L__main12:
	BTFSC       STATUS+0, 2 
	GOTO        L_main5
;MyProject.c,61 :: 		BarSegmentNum = adc_rd/(1023/16); // Calculate numbers of bar graph segments
	MOVLW       63
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        _adc_rd+0, 0 
	MOVWF       R0 
	MOVF        _adc_rd+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_U+0, 0
	MOVF        R0, 0 
	MOVWF       _BarSegmentNum+0 
	MOVF        R1, 0 
	MOVWF       _BarSegmentNum+1 
	MOVLW       0
	MOVWF       _BarSegmentNum+2 
	MOVWF       _BarSegmentNum+3 
;MyProject.c,63 :: 		Lcd_out(2,1,"                ");  // Clears LCD second row
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr1_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr1_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,65 :: 		for (i=0;i<BarSegmentNum;i++)     // Loop to print each bar segment in second row
	CLRF        _i+0 
L_main6:
	MOVF        _BarSegmentNum+3, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main13
	MOVF        _BarSegmentNum+2, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main13
	MOVF        _BarSegmentNum+1, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main13
	MOVF        _BarSegmentNum+0, 0 
	SUBWF       _i+0, 0 
L__main13:
	BTFSC       STATUS+0, 0 
	GOTO        L_main7
;MyProject.c,67 :: 		CustomChar(2,i+1);          // Print custom character for bargraph segment
	MOVLW       2
	MOVWF       FARG_CustomChar_pos_row+0 
	MOVF        _i+0, 0 
	ADDLW       1
	MOVWF       FARG_CustomChar_pos_char+0 
	CALL        _CustomChar+0, 0
;MyProject.c,65 :: 		for (i=0;i<BarSegmentNum;i++)     // Loop to print each bar segment in second row
	INCF        _i+0, 1 
;MyProject.c,68 :: 		}
	GOTO        L_main6
L_main7:
;MyProject.c,69 :: 		}
L_main5:
;MyProject.c,70 :: 		Delay_ms(1500);                   // Stabilize LCD display
	MOVLW       61
	MOVWF       R11, 0
	MOVLW       225
	MOVWF       R12, 0
	MOVLW       63
	MOVWF       R13, 0
L_main9:
	DECFSZ      R13, 1, 1
	BRA         L_main9
	DECFSZ      R12, 1, 1
	BRA         L_main9
	DECFSZ      R11, 1, 1
	BRA         L_main9
	NOP
	NOP
;MyProject.c,72 :: 		diff = adc_rd;
	MOVF        _adc_rd+0, 0 
	MOVWF       _diff+0 
	MOVF        _adc_rd+1, 0 
	MOVWF       _diff+1 
;MyProject.c,74 :: 		}
	GOTO        L_main3
;MyProject.c,76 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
