
_main:

;MyProject.c,38 :: 		void main()
;MyProject.c,40 :: 		ANSELA.F0 = 1;            // Configure RA0 pin as analog
	BSF         ANSELA+0, 0 
;MyProject.c,41 :: 		TRISA.F0  = 1;            // Configure RA0 pin as input
	BSF         TRISA+0, 0 
;MyProject.c,43 :: 		Lcd_Init();               // Initialize LCD
	CALL        _Lcd_Init+0, 0
;MyProject.c,44 :: 		Lcd_Cmd(_LCD_CLEAR);      // Clear LCD
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,45 :: 		Lcd_Cmd(_LCD_CURSOR_OFF); // Turn cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,47 :: 		ADC_Init();
	CALL        _ADC_Init+0, 0
;MyProject.c,49 :: 		while(1)
L_main0:
;MyProject.c,51 :: 		adc_rd = ADC_Get_Sample(0);         // Get ADC value from 1st channel
	CLRF        FARG_ADC_Get_Sample_channel+0 
	CALL        _ADC_Get_Sample+0, 0
	MOVF        R0, 0 
	MOVWF       _adc_rd+0 
	MOVF        R1, 0 
	MOVWF       _adc_rd+1 
;MyProject.c,53 :: 		if (diff != adc_rd)
	MOVF        _diff+1, 0 
	XORWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main64
	MOVF        R0, 0 
	XORWF       _diff+0, 0 
L__main64:
	BTFSC       STATUS+0, 2 
	GOTO        L_main2
;MyProject.c,55 :: 		Lcd_out(1,1,"       ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr1_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr1_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,56 :: 		Lcd_out(2,1,"       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr2_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr2_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,58 :: 		if (adc_rd < 205)
	MOVLW       0
	SUBWF       _adc_rd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main65
	MOVLW       205
	SUBWF       _adc_rd+0, 0 
L__main65:
	BTFSC       STATUS+0, 0 
	GOTO        L_main3
;MyProject.c,60 :: 		Lcd_out(1,1,"1");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr3_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr3_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,61 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,62 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character1[ip]);
	CLRF        _ip+0 
L_main4:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main5
	MOVLW       _character1+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character1+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character1+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main4
L_main5:
;MyProject.c,63 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,64 :: 		Lcd_Chr(2,1, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,65 :: 		}
L_main3:
;MyProject.c,66 :: 		if ((adc_rd > 205) && (adc_rd < 410))
	MOVLW       0
	MOVWF       R0 
	MOVF        _adc_rd+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main66
	MOVF        _adc_rd+0, 0 
	SUBLW       205
L__main66:
	BTFSC       STATUS+0, 0 
	GOTO        L_main9
	MOVLW       1
	SUBWF       _adc_rd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main67
	MOVLW       154
	SUBWF       _adc_rd+0, 0 
L__main67:
	BTFSC       STATUS+0, 0 
	GOTO        L_main9
L__main62:
;MyProject.c,68 :: 		Lcd_out(1,1,"1");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr4_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr4_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,69 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,70 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character1[ip]);
	CLRF        _ip+0 
L_main10:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main11
	MOVLW       _character1+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character1+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character1+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main10
L_main11:
;MyProject.c,71 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,72 :: 		Lcd_Chr(2,1, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,74 :: 		Lcd_out(1,2,"2");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr5_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr5_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,75 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,76 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character2[ip]);
	CLRF        _ip+0 
L_main13:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main14
	MOVLW       _character2+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character2+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character2+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main13
L_main14:
;MyProject.c,77 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,78 :: 		Lcd_Chr(2,2, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,79 :: 		}
L_main9:
;MyProject.c,80 :: 		if ((adc_rd > 410) && (adc_rd < 615))
	MOVF        _adc_rd+1, 0 
	SUBLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__main68
	MOVF        _adc_rd+0, 0 
	SUBLW       154
L__main68:
	BTFSC       STATUS+0, 0 
	GOTO        L_main18
	MOVLW       2
	SUBWF       _adc_rd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main69
	MOVLW       103
	SUBWF       _adc_rd+0, 0 
L__main69:
	BTFSC       STATUS+0, 0 
	GOTO        L_main18
L__main61:
;MyProject.c,82 :: 		Lcd_out(1,1,"1");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr6_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr6_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,83 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,84 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character1[ip]);
	CLRF        _ip+0 
L_main19:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main20
	MOVLW       _character1+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character1+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character1+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main19
L_main20:
;MyProject.c,85 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,86 :: 		Lcd_Chr(2,1, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,88 :: 		Lcd_out(1,2,"2");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr7_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr7_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,89 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,90 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character2[ip]);
	CLRF        _ip+0 
L_main22:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main23
	MOVLW       _character2+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character2+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character2+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main22
L_main23:
;MyProject.c,91 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,92 :: 		Lcd_Chr(2,2, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,94 :: 		Lcd_out(1,3,"3");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr8_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr8_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,95 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,96 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character3[ip]);
	CLRF        _ip+0 
L_main25:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main26
	MOVLW       _character3+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character3+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character3+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main25
L_main26:
;MyProject.c,97 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,98 :: 		Lcd_Chr(2,3, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,99 :: 		}
L_main18:
;MyProject.c,100 :: 		if ((adc_rd > 615) && (adc_rd < 820))
	MOVF        _adc_rd+1, 0 
	SUBLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__main70
	MOVF        _adc_rd+0, 0 
	SUBLW       103
L__main70:
	BTFSC       STATUS+0, 0 
	GOTO        L_main30
	MOVLW       3
	SUBWF       _adc_rd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main71
	MOVLW       52
	SUBWF       _adc_rd+0, 0 
L__main71:
	BTFSC       STATUS+0, 0 
	GOTO        L_main30
L__main60:
;MyProject.c,102 :: 		Lcd_out(1,1,"1");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr9_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr9_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,103 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,104 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character1[ip]);
	CLRF        _ip+0 
L_main31:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main32
	MOVLW       _character1+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character1+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character1+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main31
L_main32:
;MyProject.c,105 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,106 :: 		Lcd_Chr(2,1, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,108 :: 		Lcd_out(1,2,"2");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr10_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr10_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,109 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,110 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character2[ip]);
	CLRF        _ip+0 
L_main34:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main35
	MOVLW       _character2+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character2+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character2+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main34
L_main35:
;MyProject.c,111 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,112 :: 		Lcd_Chr(2,2, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,114 :: 		Lcd_out(1,3,"3");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr11_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr11_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,115 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,116 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character3[ip]);
	CLRF        _ip+0 
L_main37:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main38
	MOVLW       _character3+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character3+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character3+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main37
L_main38:
;MyProject.c,117 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,118 :: 		Lcd_Chr(2,3, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,120 :: 		Lcd_out(1,4,"4");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       4
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr12_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr12_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,121 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,122 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character4[ip]);
	CLRF        _ip+0 
L_main40:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main41
	MOVLW       _character4+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character4+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character4+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main40
L_main41:
;MyProject.c,123 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,124 :: 		Lcd_Chr(2,4, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       4
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,125 :: 		}
L_main30:
;MyProject.c,126 :: 		if (adc_rd > 820)
	MOVF        _adc_rd+1, 0 
	SUBLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__main72
	MOVF        _adc_rd+0, 0 
	SUBLW       52
L__main72:
	BTFSC       STATUS+0, 0 
	GOTO        L_main43
;MyProject.c,128 :: 		Lcd_out(1,1,"1");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr13_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr13_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,129 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,130 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character1[ip]);
	CLRF        _ip+0 
L_main44:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main45
	MOVLW       _character1+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character1+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character1+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main44
L_main45:
;MyProject.c,131 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,132 :: 		Lcd_Chr(2,1, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,134 :: 		Lcd_out(1,2,"2");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr14_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr14_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,135 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,136 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character2[ip]);
	CLRF        _ip+0 
L_main47:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main48
	MOVLW       _character2+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character2+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character2+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main47
L_main48:
;MyProject.c,137 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,138 :: 		Lcd_Chr(2,2, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,140 :: 		Lcd_out(1,3,"3");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr15_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr15_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,141 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,142 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character3[ip]);
	CLRF        _ip+0 
L_main50:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main51
	MOVLW       _character3+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character3+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character3+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main50
L_main51:
;MyProject.c,143 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,144 :: 		Lcd_Chr(2,3, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,146 :: 		Lcd_out(1,4,"4");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       4
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr16_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr16_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,147 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,148 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character4[ip]);
	CLRF        _ip+0 
L_main53:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main54
	MOVLW       _character4+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character4+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character4+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main53
L_main54:
;MyProject.c,149 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,150 :: 		Lcd_Chr(2,4, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       4
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,152 :: 		Lcd_out(1,5,"5");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       5
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr17_MyProject+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr17_MyProject+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;MyProject.c,153 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,154 :: 		for (ip=0;ip<=7;ip++) Lcd_Chr_Cp(character5[ip]);
	CLRF        _ip+0 
L_main56:
	MOVF        _ip+0, 0 
	SUBLW       7
	BTFSS       STATUS+0, 0 
	GOTO        L_main57
	MOVLW       _character5+0
	ADDWF       _ip+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       hi_addr(_character5+0)
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      TBLPTRH, 1 
	MOVLW       higher_addr(_character5+0)
	MOVWF       TBLPTRU 
	MOVLW       0
	ADDWFC      TBLPTRU, 1 
	TBLRD*+
	MOVFF       TABLAT+0, FARG_Lcd_Chr_CP_out_char+0
	CALL        _Lcd_Chr_CP+0, 0
	INCF        _ip+0, 1 
	GOTO        L_main56
L_main57:
;MyProject.c,155 :: 		Lcd_Cmd(_LCD_RETURN_HOME);
	MOVLW       2
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;MyProject.c,156 :: 		Lcd_Chr(2,5, 0);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       5
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;MyProject.c,157 :: 		}
L_main43:
;MyProject.c,158 :: 		}
L_main2:
;MyProject.c,159 :: 		Delay_ms(1000);  // Stabilize LCD display
	MOVLW       41
	MOVWF       R11, 0
	MOVLW       150
	MOVWF       R12, 0
	MOVLW       127
	MOVWF       R13, 0
L_main59:
	DECFSZ      R13, 1, 1
	BRA         L_main59
	DECFSZ      R12, 1, 1
	BRA         L_main59
	DECFSZ      R11, 1, 1
	BRA         L_main59
;MyProject.c,160 :: 		diff = adc_rd;
	MOVF        _adc_rd+0, 0 
	MOVWF       _diff+0 
	MOVF        _adc_rd+1, 0 
	MOVWF       _diff+1 
;MyProject.c,161 :: 		}
	GOTO        L_main0
;MyProject.c,162 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
